<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\performance;


use app\common\model\performance\PerformanceRules;
use app\common\logic\BaseLogic;
use think\facade\Db;


/**
 * PerformanceRules逻辑
 * Class PerformanceRulesLogic
 * @package app\adminapi\logic\performance
 */
class PerformanceRulesLogic extends BaseLogic
{


    /**
     * @notes 添加
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/07/15 17:52
     */
    public static function add(array $params): bool
    {
        Db::startTrans();
        try {
            $goodsCategoryIds = [];
            if(  !empty($params['goods_category_ids']) && is_array($params['goods_category_ids'])){
                foreach($params['goods_category_ids'] as $v){
                    $goodsCategoryIds[] = end($v);
                }
            }
            PerformanceRules::create([
                'goods_category_ids' => $goodsCategoryIds,
                'type' => $params['type'],
                'rate' => $params['rate'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 编辑
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/07/15 17:52
     */
    public static function edit(array $params): bool
    {
        Db::startTrans();
        try {
            $goodsCategoryIds = [];
            if(!empty($params['goods_category_ids']) && is_array($params['goods_category_ids'])){
                foreach($params['goods_category_ids'] as $v){
                    if(is_array($v)){
                        $goodsCategoryIds[] = end($v);
                    } else {
                        $goodsCategoryIds[] = $v;
                    }
                }
            }
            PerformanceRules::where('id', $params['id'])->update([
                'goods_category_ids' => implode(',',$goodsCategoryIds),
                'type' => $params['type'],
                'rate' => $params['rate'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 删除
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/07/15 17:52
     */
    public static function delete(array $params): bool
    {
        return PerformanceRules::destroy($params['id']);
    }


    /**
     * @notes 获取详情
     * @param $params
     * @return array
     * @author likeadmin
     * @date 2024/07/15 17:52
     */
    public static function detail($params): array
    {
        return PerformanceRules::findOrEmpty($params['id'])->toArray();
    }
}